﻿

Procedure.s SplitJson(*json.byte,posi)
  Static *oldstring
  Static oldi
  Static oldfound
  Static olddeep
  
  inchr34=#False
  ret$=""
  
  startpos=0
  endpos=0
  
  l=MemoryStringLength(*json)  
  *char.byte=*json
  
  If *json=*oldstring And posi>=oldfound 
    *char+oldi-1
    deep=olddeep
    foundpos=oldfound
  Else
    oldi=1
    *oldstring=*json
    deep=0
    foundpos=0
  EndIf
  
  
  For i=oldi To L
    ;c$=Mid(json$,i,1)
    c=*char\b &$FF:*char+1
    
    oldi=i
    olddeep=deep
    oldfound=foundpos
    
    If c=34
      inchr34!1
    EndIf
    If inchr34=#False
      
      
      If c='[' Or c='{' 
        
        deep+1
      ElseIf c='}' Or c=']'
        deep-1
      EndIf
      
      If c=',' And deep=0
        foundpos+1
        If foundpos>posi
          Break
        EndIf
        
      Else
        If foundpos=posi
          If startpos=0:startpos=i:EndIf
          endpos=i
          ;ret$+c$
        EndIf
      EndIf
      
    Else
      If foundpos=posi
        ;ret$+c$
        If startpos=0:startpos=i:EndIf
        endpos=i
      EndIf
    EndIf   
    
    
  Next
  
  If endpos<>0
    ProcedureReturn PeekS(*json+startpos-1,endpos-startpos+1)
  Else
    ProcedureReturn ""
  EndIf  
EndProcedure
Procedure.s GetKey(Key$,*json.byte,def$="")
  
  a$="":
  deep=0
  inkey=#True;
  inchr34=#False
  key$=Chr(34)+key$+Chr(34)
  
  ret$=""
  foundkey$=""
  
  If *json\b='[' Or *json\b='{'
    offset=1
  Else
    offset=0
  EndIf
  
  l=MemoryStringLength(*json)
  *char.byte=*json+offset
  
  
  c$=Space(l+1)      
  *out.byte=@c$
  
  For I=1+offset To L-offset
    ;c$=Mid(json$,i,1)
    c=*char\b &$FF:*char+1
    
    If c=34
      inchr34!1
    EndIf
    If inchr34=#False
      
      dochr=#True
      
      
      If c=':' And deep=0 And inkey=#True
        *out\b=0:foundkey$=PeekS(@c$)        
        
        inkey=#False
        *out.byte=@c$
        dochr=#False
      ElseIf c='[' Or c='{'
        deep+1
      ElseIf c=']' Or c='}'
        deep-1
      ElseIf c=',' And deep=0
        inkey=#True
        If key$=foundkey$
          Break
        EndIf  
        
        foundkey$=""
        *out.byte=@c$
      Else
        *out\b=c:*out+1
        dochr=#False
      EndIf
      
      If dochr And inkey=#False
        *out\b=c:*out+1
      EndIf   
      
      
    Else
      *out\b=c:*out+1
    EndIf
  Next
  If key$=foundkey$
    *out\b=0:ret$=PeekS(@c$)
  EndIf
  If ret$
    If Left(ret$,1)=Chr(34) Or Left(ret$,1)="{" Or Left(ret$,1)="["
      ret$=Mid(ret$,2,Len(ret$)-2)
    EndIf
  Else
    ret$=def$
  EndIf
  
  
  ProcedureReturn ret$
EndProcedure

Procedure.s clear_JSON(b$)
  in=#False
  l=Len(b$)
  c$=Space(l+1)
  
  *out.byte=@c$
  *in.byte=@b$
  
  For I=1 To L
    c=*in\b:*in+1
    If c=34
      in!1
    EndIf
    If (c<>' ' And c<>9 And c<>10 And c<>13) Or in=#True
      ;json$+c$
      *out\b=c:*out+1
    EndIf
    
  Next
  *out\b=0
  json$=PeekS(@c$)
  ProcedureReturn json$
EndProcedure

Procedure.s MyLoadJSON(dir$)
  If GetExtensionPart(dir$)<>"json"
    If ExamineDirectory(0,dir$,"*.json")
      While NextDirectoryEntry(0)
        If DirectoryEntryType(0) = #PB_DirectoryEntry_File
          file$= dir$+"\"+DirectoryEntryName(0) 
          Break
        EndIf
      Wend
      FinishDirectory(0)
    EndIf
  Else
    file$=dir$
  EndIf
  
  If file$
    
    If ReadFile(1,file$)
      b$=""
      While Not Eof(1)
        b$+ReadString(1)
      Wend  
      CloseFile(1)
      
      json$=clear_JSON(b$)
      
      
    EndIf
  EndIf
  ProcedureReturn json$
EndProcedure
Procedure.s MyLoadJsonMem(*pos,length)
  a$=PeekS(*pos,length)
  ProcedureReturn clear_JSON(a$)
EndProcedure
Procedure.s PackLoadJson(nr)
  size=PackEntrySize(nr)
  *mem=AllocateMemory(size+10)
  UncompressPackMemory(nr,*mem,size)
  json$=MyLoadJsonMem(*mem,size)
  FreeMemory(*mem)
  ProcedureReturn json$
EndProcedure


; IDE Options = PureBasic 5.30 (Windows - x64)
; CursorPosition = 232
; Folding = A-
; EnableUnicode
; EnableXP