﻿
Procedure PackFind(nr,a$)
  ret=#False
  If ExaminePack(nr)
    While NextPackEntry(nr)
      If PackEntryName(nr)=a$
        ret=#True
        Break
      EndIf
    Wend
  EndIf
  ProcedureReturn ret
EndProcedure
Procedure.s Crypt(name$,pass$,countprof)
  If pass$=""
    ProcedureReturn ""
  EndIf
  
  key$=name$+Str(countprof)+GetEnvironmentVariable("USERNAME")+"#"+GetEnvironmentVariable("COMPUTERNAME")
  md5$=MD5Fingerprint(@key$,Len(key$))
  *Key=AllocateMemory(16)
  For i=0 To 15
    PokeB(*key+i,Val("$"+Mid(md5$,i*2+1,2)))
  Next

  mlen=Len(pass$)+17+Random(20)
  *pass=AllocateMemory(mlen)
  PokeS(*pass,pass$)
  For i=Len(pass$)+1 To mlen-1
    PokeB(*pass+i,Random(255))
  Next

  *Crypt=AllocateMemory(mlen)
  *b64=AllocateMemory(mlen*2+64)

  AESEncoder(*pass,*crypt,mlen,*key,128,0,#PB_Cipher_ECB)
  blen=Base64Encoder(*crypt,mlen,*b64,mlen*2+63)
  b64$=PeekS(*b64,blen)

  FreeMemory(*b64)
  FreeMemory(*Crypt)
  FreeMemory(*Pass)
  FreeMemory(*key)
  ProcedureReturn b64$
EndProcedure


Procedure.s DeCrypt(name$,b64$,countprof)
  If b64$="" Or name$=""
    ProcedureReturn ""
  EndIf
  
  key$=name$+Str(countprof)+GetEnvironmentVariable("USERNAME")+"#"+GetEnvironmentVariable("COMPUTERNAME")
  md5$=MD5Fingerprint(@key$,Len(key$))
  *Key=AllocateMemory(16)
  For i=0 To 15
    PokeB(*key+i,Val("$"+Mid(md5$,i*2+1,2)))
  Next
  
  *b64=AllocateMemory(Len(b64$)*2)
  mlen=Base64Decoder(@b64$,Len(b64$),*b64,Len(b64$)*2-1) 
  
  *DeCrypt=AllocateMemory(mlen)
  AESDecoder(*b64,*DeCrypt,mlen,*key,128,0,#PB_Cipher_ECB)
  pass$=PeekS(*DeCrypt)
  
  FreeMemory(*DeCrypt)
  FreeMemory(*b64)
  FreeMemory(*key)
  ProcedureReturn pass$
EndProcedure

Procedure OpenWinInfo(info.s)
  If IsWindow(1)
    CloseWindow(1)
  EndIf
  
  OpenWindow(1,0,0,400,10+20+5+20+5+20,info,#PB_Window_Tool |#PB_Window_WindowCentered,WindowID(0))
  If IsWindow(0)
    DisableWindow(0,#True)
  EndIf
  
  y=5
  TextGadget(#gtxt_w1_text1,5,y,WindowWidth(1)-10,20,"",#PB_Text_Center):y+25
  TextGadget(#gtxt_w1_text2,5,y,WindowWidth(1)-10,20,"",#PB_Text_Center):y+25
  ProgressBarGadget(#gPRO_W1_Balken,5,y,WindowWidth(1)-10,20,0,100,#PB_ProgressBar_Smooth):y+25
  HideGadget(#gPRO_W1_Balken,#True)
  While WindowEvent():Wend:Delay(0)
EndProcedure
Procedure CloseWinInfo()
  If IsWindow(0)
    DisableWindow(0,#False)
    SetActiveWindow(0)
  EndIf
  If IsWindow(1)
    CloseWindow(1)
  EndIf
  If IsWindow(0)
    UseGadgetList(WindowID(0))
  EndIf
  
EndProcedure
Procedure WinInfoB(prozent=-1)
  ;debug "setbalken "+Str(prozent)
  If IsGadget(#gPRO_W1_Balken)
    If prozent>=0
      HideGadget(#gPRO_W1_Balken,#False)
      SetGadgetState(#gPRO_W1_Balken,prozent)
    Else
      HideGadget(#gPRO_W1_Balken,#True)
    EndIf
  EndIf
  While WindowEvent():Wend:Delay(0)
EndProcedure

Procedure WinInfo2(txt2.s)
  If IsGadget(#gTXT_W1_Text2)
    SetGadgetText(#gtxt_w1_text2,txt2)
    While WindowEvent():Wend:Delay(0)
  EndIf
EndProcedure

Procedure WinInfo1(txt1.s)
  If IsGadget(#gTXT_W1_Text1)
    SetGadgetText(#gtxt_w1_text1,txt1)
  EndIf
  
  While WindowEvent():Wend:Delay(0)
  
EndProcedure
Procedure WinInfo(txt1.s,txt2.s,prozent=-1)
  WinInfo1(txt1)
  WinInfo2(txt2)
  WinInfoB(prozent)
EndProcedure


Procedure EnumWin(hwnd,*minewin.long)
  enumwinbuff=AllocateMemory(1024)
  l=GetWindowText_(hwnd,enumwinbuff,1000)
  If l>8 And l<1023
    a$=PeekS(enumwinbuff,l)
    If Left(a$,11)="Minecraft 1" Or a$="Minecraft"
      l=GetClassName_(hwnd,enumwinbuff,1023)
      If l>0 And l<1023
        c$= PeekS(enumwinbuff,l)
        If Left(c$,7)<>"Cabinet" And Left(c$,11)<>"WindowClass"
          *minewin\l=hwnd      
        EndIf    
      EndIf
    EndIf
    FreeMemory(enumwinbuff)
  EndIf
  ProcedureReturn #True
EndProcedure


Procedure ForceDirectories(Dir.s) 
  If Len(Dir.s) = 0 
    result = #False 
  Else 
    If (Right(Dir.s, 1) = "\") 
      Dir.s = Left(Dir.s, Len(Dir.s)-1) 
    EndIf 
    If (Len(Dir.s) < 3) Or FileSize(Dir.s) = -2 Or GetPathPart(Dir.s)= Dir.s 
      ProcedureReturn #False 
    EndIf 
    ForceDirectories(GetPathPart(Dir.s)); 
    CreateDirectory(Dir.s)              ; 
    ProcedureReturn #True 
  EndIf 
EndProcedure

Procedure.s SearchFile(file$)
  d=ExamineDirectory(#PB_Any,GetPathPart(file$),GetFilePart(file$))
  
  If d
    
    If NextDirectoryEntry(d)
      
      ret$=GetPathPart(file$)+DirectoryEntryName(d)
    EndIf
    FinishDirectory(d)
  EndIf
  ProcedureReturn ret$
EndProcedure
Procedure HiddenStringGadget(gad)
  StringGadget(gad,0,0,10,10,"")
  HideGadget(gad,#True)
EndProcedure
Procedure AddWeb(gad,name$,url$)
  AddGadgetItem(#gPNL_NewsDir,-1,name$)
  x=gad-#gWeb_Start
  ButtonGadget(#gWeb_back+x,0,0,20,20,"<")
  ButtonGadget(#gWeb_home+x,20,0,20,20,"H")
  StringGadget(#gWeb_URL+x,40,0,GetGadgetAttribute(#gPNL_NewsDir,#PB_Panel_ItemWidth)-20,20,url$,#PB_String_ReadOnly|#PB_String_BorderLess)
  WebGadget(gad,0,20,GetGadgetAttribute(#gPNL_NewsDir,#PB_Panel_ItemWidth),GetGadgetAttribute(#gPNL_NewsDir,#PB_Panel_ItemHeight)-20,url$)
  SetGadgetAttribute(gad,#PB_Web_NavigationCallback,@NavigationCallback())
  
   MyWebGadget.IWebBrowser2=GetWindowLong_(GadgetID(gad),#GWL_USERDATA)
   MyWebGadget\put_Silent(#True) ; Suppress JavaScript error messages.
                                 ;MyWebGadget\put_AddressBar(#True)
  
  
  AddElement(web())
  web()\home=url$
  web()\panel=CountGadgetItems(#gPNL_NewsDir)-1
  web()\gadget=gad
  
EndProcedure

; IDE Options = PureBasic 5.30 (Windows - x64)
; CursorPosition = 201
; FirstLine = 47
; Folding = kw-
; EnableUnicode
; EnableXP